package com.ycwl.basic.repository;

import com.alibaba.fastjson.JSONObject;
import com.ycwl.basic.mapper.TaskMapper;
import com.ycwl.basic.mapper.VideoMapper;
import com.ycwl.basic.model.pc.task.entity.TaskEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

@Component
public class VideoTaskRepository {
    @Autowired
    private RedisTemplate<String, String> redisTemplate;
    @Autowired
    private TaskMapper taskMapper;
    @Autowired
    private VideoMapper videoMapper;

    public static final String TASK_CACHE_KEY = "task:byId:%s";

    public TaskEntity getTaskById(Long taskId) {
        if (redisTemplate.hasKey(String.format(TASK_CACHE_KEY, taskId))) {
            return JSONObject.parseObject(redisTemplate.opsForValue().get(String.format(TASK_CACHE_KEY, taskId)), TaskEntity.class);
        } else {
            TaskEntity task = taskMapper.get(taskId);
            if (task != null && 1 == task.getStatus()) {
                redisTemplate.opsForValue().set(String.format(TASK_CACHE_KEY, taskId), JSONObject.toJSONString(task));
            }
            return task;
        }
    }

    public void clearTaskCache(Long taskId) {
        redisTemplate.delete(String.format(TASK_CACHE_KEY, taskId));
    }
}
